product/config/routes.rb
Rails.application.routes.draw do
  resources :tasks do
    member do
      patch :up
      patch :down
    end
  end
  resources :projects
  namespace :admin do
    resources :users
    resources :admin_users
    resources :overtimes

    root to: "users#index"
  end
  devise_for :users, skip: [:registrations]
  resources :overtimes
  root to: 'static#homepage'
end

product/app/models/project.rb
class Project < ApplicationRecord
  include Sizeable
  
  has_many :tasks, -> { order "project_order ASC" },
    dependent: :destroy, inverse_of: :project
  validates :name, presence: true

  # completeness
  def incomplete_tasks
    tasks.reject(&:complete?)
  end

  def done?
    incomplete_tasks.empty?
  end

  def size
    tasks.sum(&:size)
  end

  def remaining_size
    incomplete_tasks.sum(&:size)
  end

  # velocity
  def self.velocity_length_in_days
    21
  end

  def completed_velocity
    tasks.sum(&:points_toward_velocity)
  end

  def current_rate
    completed_velocity * 1.0 / Project.velocity_length_in_days
  end

  def projected_days_remaining
    remaining_size / current_rate
  end
  
  def on_schedule?
    return false if projected_days_remaining.nan?
    (Time.zone.today + projected_days_remaining) <= due_date
  end

  # order
  def next_task_order
    return 1 if tasks.empty?
    (tasks.last.project_order || tasks.size) + 1
  end
end

product/app/controllers/projects_controller.rb
class ProjectsController < ApplicationController

  def index
    @projects = Project.all
  end

  def show
    @project = Project.find(params[:id])
  end

  def new
    @project = Project.new
  end

  def create
    @workflow = ProjectFactory.new(
      name: params[:project][:name],
      task_string: params[:project][:tasks]
    )
    @workflow.create
    if @workflow.success?
      redirect_to projects_path
    else
      @project = @workflow.project
      render :new
    end
  end
end

product/app/helpers/projects_helper.rb
module ProjectsHelper
end

product/app/views/projects/index.html.erb
<h1>All Projects</h1>
<table>
  <thead>
    <tr>
      <td>Project Name</td>
      <td>Total Project Size</td>
    </tr>
  </thead>
  <tbody>
    <% @projects.each do |project| %>
      <tr class='project-row' id='<%= dom_id(project) %>'>
        <td class='name'><%= project.name %></td>
        <td class='total-size'><%= project.size %></td>
      </tr>
    <% end %>
  </tbody>
</table>

product/app/views/projects/new.html.erb
<h1> New Project </h1>

<%= form_for(@project) do |f| %>

<%= f.label(:name) %>
<%= f.text_field(:name) %>
<br/>

<%= f.label(:tasks) %>
<%= text_area_tag('project[tasks]') %>
<br/>

<%= f.submit %>

<% end %>

product/app/views/projects/show.html.erb
<h2>Project <%= @project.name %></h2>

<h3>Existing Tasks:</h3>

<table>
  <%= thead ['Name', 'Size'] %>
  <tbody>
    <% @project.tasks.each do |task| %>
      <%= tag.tr id: "task_#{task.project_order}" do %>
        <td class='name'><%= task.title %></td>
        <td class='size'><%= task.size %></td>
        <td class='completed'><%= task.completed_at %></td>

        <% unless task.first_in_project? %>
          <%= link_to 'Up', up_task_path(task.id), method: :patch %>
        <% end %>

        <% unless task.last_in_project? %>
          <%= link_to 'Down', down_task_path(task.id), method: :patch %>
        <% end %>

      <% end %>
    <% end %>
  </tbody>
</table>

<h3>New Task</h3>

<%= form_for Task.new(project_id: @project.id) do |f| %>
  <%= f.hidden_field :project_id %>

  <%= f.label :title, "Task" %>
  <%= f.text_field :title %>

  <%= f.label :size %>
  <%= f.select :size, [1,2,3,4,5] %>

  <%= f.submit 'Add Task' %>
<% end %>